Bug 112569 - hard lockup in via82cxxx_audio.c
hard lockup in via82cxxx_audio.c
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
athlon Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
Depends On:
  Show dependency treegraph
Reported: 2003-12-22 20:58 EST by Robert Hwang
Modified: 2007-04-18 13:00 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2004-09-30 11:41:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Test case. (378 bytes, text/plain)
2003-12-22 20:59 EST, Robert Hwang
no flags Details
This seems to fix via82cxxx_audio.c on my machine. (356 bytes, patch)
2003-12-22 21:00 EST, Robert Hwang
no flags Details | Diff

  None (edit)
Description Robert Hwang 2003-12-22 20:58:26 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.5)
Gecko/20031007 Firebird/0.7

Description of problem:
I experienced frequent hard lock ups in Gnome whenever using
find-ahead-type in Mozilla Firebird and when logging out.

This likely seems to be related to 76603 or 80968.  

It seems to be a problem with via82cxxx_audio.c.

Both Gnome and the find-ahead-type feature in Firebird make use of esound.

Esound, upon startup, opens /dev/dsp, performs the usual OSS
initializations with SNDCTL_DSP_SETFRAGMENT and SNDCTL_DSP_SETFMT etc,
and then writes a NULL buffer with 0 bytes (for whatever reason; not
being an OSS expert, I can't say why it might be necessary) and then
performs a SNDCTL_DSP_POST.

It appears that the sequence of actions in the attached test case can
cause a lockup in via82cxxx_audio.c if it occurs immediately after
modprobe via82cxxx_audio.

Modifying via82cxxx_audio.c as in the attachment seemed to fix the
problem for me.  I don't claim that this is the "right" fix, but
perhaps it will help whoever looks at this.  Possibly the hardware
does not like putting VIA_EOL | VIA_STOP on zero length fragments
immediately after bootup, or possibly the hardware is not fully
initialized -- I cannot say.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
Logout from Gnome or type URL into Mozilla Firebird with
Find-Ahead-Type enabled.

Actual Results:  Hard lockup.  No system response.  Have to reboot
with power switch.

Expected Results:  No hard lockup.

Additional info:
Comment 1 Robert Hwang 2003-12-22 20:59:22 EST
Created attachment 96676 [details]
Test case.
Comment 2 Robert Hwang 2003-12-22 21:00:42 EST
Created attachment 96677 [details]
This seems to fix via82cxxx_audio.c on my machine.

Not suggesting this is the "right" fix.  But perhaps it will help whoever looks
at the problem.
Comment 3 Bugzilla owner 2004-09-30 11:41:45 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.